/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TCoreStudy.TCoreStudyPath;
import de.ship.db.tables.records.TDmDocumentationRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmDocumentation extends TableImpl<TDmDocumentationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_documentation</code>
     */
    public static final TDmDocumentation T_DM_DOCUMENTATION = new TDmDocumentation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmDocumentationRecord> getRecordType() {
        return TDmDocumentationRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_documentation.lastchange</code>.
     */
    public final TableField<TDmDocumentationRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_documentation.pk</code>.
     */
    public final TableField<TDmDocumentationRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_documentation.study</code>. foreign key
     * to study id
     */
    public final TableField<TDmDocumentationRecord, Integer> STUDY = createField(DSL.name("study"), SQLDataType.INTEGER.nullable(false), this, "foreign key to study id");

    /**
     * The column <code>common_dd.t_dm_documentation.dd_group</code>. DD group
     */
    public final TableField<TDmDocumentationRecord, String> DD_GROUP = createField(DSL.name("dd_group"), SQLDataType.CLOB, this, "DD group");

    /**
     * The column <code>common_dd.t_dm_documentation.path</code>.
     */
    public final TableField<TDmDocumentationRecord, String> PATH = createField(DSL.name("path"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_dm_documentation.filename</code>.
     */
    public final TableField<TDmDocumentationRecord, String> FILENAME = createField(DSL.name("filename"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_dm_documentation.version</code>. version
     * number of the document
     */
    public final TableField<TDmDocumentationRecord, String> VERSION = createField(DSL.name("version"), SQLDataType.CLOB.nullable(false), this, "version number of the document");

    /**
     * The column <code>common_dd.t_dm_documentation.responsible</code>. foreign
     * key to usnr
     */
    public final TableField<TDmDocumentationRecord, Integer> RESPONSIBLE = createField(DSL.name("responsible"), SQLDataType.INTEGER, this, "foreign key to usnr");

    /**
     * The column <code>common_dd.t_dm_documentation.release_date</code>.
     * release date of the document
     */
    public final TableField<TDmDocumentationRecord, LocalDateTime> RELEASE_DATE = createField(DSL.name("release_date"), SQLDataType.LOCALDATETIME(6), this, "release date of the document");

    /**
     * The column <code>common_dd.t_dm_documentation.status</code>. 0 - archive,
     * 1 = productive
     */
    public final TableField<TDmDocumentationRecord, Integer> STATUS = createField(DSL.name("status"), SQLDataType.INTEGER.nullable(false), this, "0 - archive, 1 = productive");

    private TDmDocumentation(Name alias, Table<TDmDocumentationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmDocumentation(Name alias, Table<TDmDocumentationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_documentation</code> table
     * reference
     */
    public TDmDocumentation(String alias) {
        this(DSL.name(alias), T_DM_DOCUMENTATION);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_documentation</code> table
     * reference
     */
    public TDmDocumentation(Name alias) {
        this(alias, T_DM_DOCUMENTATION);
    }

    /**
     * Create a <code>common_dd.t_dm_documentation</code> table reference
     */
    public TDmDocumentation() {
        this(DSL.name("t_dm_documentation"), null);
    }

    public <O extends Record> TDmDocumentation(Table<O> path, ForeignKey<O, TDmDocumentationRecord> childPath, InverseForeignKey<O, TDmDocumentationRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_DOCUMENTATION);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmDocumentationPath extends TDmDocumentation implements Path<TDmDocumentationRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmDocumentationPath(Table<O> path, ForeignKey<O, TDmDocumentationRecord> childPath, InverseForeignKey<O, TDmDocumentationRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmDocumentationPath(Name alias, Table<TDmDocumentationRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmDocumentationPath as(String alias) {
            return new TDmDocumentationPath(DSL.name(alias), this);
        }

        @Override
        public TDmDocumentationPath as(Name alias) {
            return new TDmDocumentationPath(alias, this);
        }

        @Override
        public TDmDocumentationPath as(Table<?> alias) {
            return new TDmDocumentationPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmDocumentationRecord, Integer> getIdentity() {
        return (Identity<TDmDocumentationRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmDocumentationRecord> getPrimaryKey() {
        return Keys.PK_DM_DOCUMENTATION;
    }

    @Override
    public List<UniqueKey<TDmDocumentationRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_DOCUMENTATION);
    }

    @Override
    public List<ForeignKey<TDmDocumentationRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_STUDY, Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_RESP);
    }

    private transient TCoreStudyPath _tCoreStudy;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_study</code>
     * table.
     */
    public TCoreStudyPath tCoreStudy() {
        if (_tCoreStudy == null)
            _tCoreStudy = new TCoreStudyPath(this, Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_STUDY, null);

        return _tCoreStudy;
    }

    private transient TCorePersonPath _tCorePerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_person</code>
     * table.
     */
    public TCorePersonPath tCorePerson() {
        if (_tCorePerson == null)
            _tCorePerson = new TCorePersonPath(this, Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_RESP, null);

        return _tCorePerson;
    }

    @Override
    public TDmDocumentation as(String alias) {
        return new TDmDocumentation(DSL.name(alias), this);
    }

    @Override
    public TDmDocumentation as(Name alias) {
        return new TDmDocumentation(alias, this);
    }

    @Override
    public TDmDocumentation as(Table<?> alias) {
        return new TDmDocumentation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmDocumentation rename(String name) {
        return new TDmDocumentation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmDocumentation rename(Name name) {
        return new TDmDocumentation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmDocumentation rename(Table<?> name) {
        return new TDmDocumentation(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation where(Condition condition) {
        return new TDmDocumentation(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmDocumentation where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmDocumentation where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmDocumentation where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmDocumentation where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmDocumentation whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
